#!/usr/bin/env python
# Copyright 2013 Renzo Davoli
# License: GPLv2+ see license.txt

import usb
import sys

CUSTOM_RQ_ECHO=0
CUSTOM_RQ_SET_STATUS=1
CUSTOM_RQ_GET_STATUS=2

c2cmd={'a':0,'b':1,'c':2,'d':3,'A':8,'B':9,'C':10,'D':11}

busses = usb.busses()
for bus in busses:
	for dev in bus.devices:
		if dev.idVendor == 0x16c0 and dev.idProduct == 0x05dc:
			if len(sys.argv) < 2:
				print "FOUND!"
			else:
				out=dev.open()

				if 	sys.argv[1] == "status":
					msg=out.controlMsg(requestType=0xc0, 
							request=CUSTOM_RQ_GET_STATUS, 
							value=0, index=0, buffer=4, timeout=5000)
					value=msg[0]
					print "OUT is", ("A" if value & 1 else "a") + ("B" if value & 2 else "b") + ("C" if value & 4 else "c") + ("D" if value & 8 else "d")

				else:
					for c in sys.argv[1]:						
						if c in c2cmd:
							msg=out.controlMsg(requestType=0x40, 
									request=CUSTOM_RQ_SET_STATUS, 
									value=c2cmd[c], index=0, buffer=4, timeout=5000)

#				msg=out.controlMsg(requestType=0xc0, request=CUSTOM_RQ_GET_STATUS, value=0, index=0, buffer=4, timeout=5000)
#				print "here works",msg

		

